#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <stdio.h>
#include <fcntl.h>
#include <stdint.h>

#define MAX_TIME_MS 5000
#define TICKS_PER_MS 25000

int main(int argc, char **argv) {
	/* 0xf1000000 is the base offset for memory mapped registers
	   0x00010050 is the actual register we want to access
	 */
	off_t addr = 0xf1010050;
	off_t page;
	char *page_start;

	volatile uint32_t *value_ptr;
	uint32_t value;
	uint32_t value_ms;

	int fd = open("/dev/mem", O_RDWR);
	page = addr & 0xfffff000;
	page_start = mmap(0, getpagesize(), PROT_READ|PROT_WRITE, MAP_SHARED, fd, page);
	value_ptr = (uint32_t *)(page_start + (addr & 0xfff));

	/* Only the lower 29 bits are valid */
	value = *value_ptr & 0x1FFFFFFF;

	/* Reset the register */
	(*value_ptr) = 0x80000000;
	close(fd);

	value_ms = value / TICKS_PER_MS;
#if 0
	printf("%u\n", value_ms);
#endif

	return !(value_ms >= MAX_TIME_MS);
}
